#!/usr/bin/env python

import sys
import os.path
import cairo
import Image

def makefont (name = 'Mono', size = 12, filename = 'font.h'):
    """ """

    surface = cairo.ImageSurface (cairo.FORMAT_A8, 256, 256)
    ctx = cairo.Context (surface)
    min_x_bearing, min_y_bearing = 0,0
    max_x_bearing, max_y_bearing = 0,0
    max_width, max_height = 0,0


    ctx.select_font_face (name, cairo.FONT_SLANT_NORMAL, cairo.FONT_WEIGHT_NORMAL)
    ctx.set_font_size (size)
    for y in range(8):
        for x in range (16):
            c = chr (y*16+x)
            x_bearing, y_bearing, width, height, x_advance, y_advance = ctx.text_extents (c)
            min_x_bearing = min (min_x_bearing, int(x_bearing))
            min_y_bearing = min (min_y_bearing, int(y_bearing))
            max_x_bearing = max (max_x_bearing, int(x_bearing))
            max_y_bearing = max (max_y_bearing, int(y_bearing))
            max_width   = max (max_width, int(width))
            max_height  = max (max_height, int(height))
    ctx.select_font_face (name, cairo.FONT_SLANT_NORMAL, cairo.FONT_WEIGHT_BOLD)
    ctx.set_font_size (size)
    for y in range(8):
        for x in range (16):
            c = chr (y*16+x)
            x_bearing, y_bearing, width, height, x_advance, y_advance = ctx.text_extents (c)
            min_x_bearing = min (min_x_bearing, int(x_bearing))
            min_y_bearing = min (min_y_bearing, int(y_bearing))
            max_x_bearing = max (max_x_bearing, int(x_bearing))
            max_y_bearing = max (max_y_bearing, int(y_bearing))
            max_width   = max (max_width, int(width))
            max_height  = max (max_height, int(height))
    ascent, descent, height, max_x_advance, max_y_advance = ctx.font_extents ()
    cw = max_width
    ch = int (ascent+descent)


    surface = cairo.ImageSurface (cairo.FORMAT_A8, 16*cw, 16*ch)
    ctx = cairo.Context (surface)
    ctx.select_font_face (name, cairo.FONT_SLANT_NORMAL, cairo.FONT_WEIGHT_NORMAL)
    ctx.set_font_size (size)
    for y in range(8):
        for x in range (16):
            c = str(chr (y*16+x))
            if (y*16+x) == 0:
                ctx.rectangle (0,0,cw-1,ch-1);
                ctx.fill()
            if (y*16+x)>31:
# With pgm, the -1,+1 shift is necessary (bug ?)
#                ctx.move_to (x*cw-min_x_bearing-1, y*ch-min_y_bearing+1)
                # Kerning problem with @ ?
                if size ==24 and c == '@':
                    ctx.move_to (x*cw-min_x_bearing-1, y*ch-min_y_bearing)
                else:
                    ctx.move_to (x*cw-min_x_bearing, y*ch-min_y_bearing)
                ctx.show_text (c)
    ctx.select_font_face (name, cairo.FONT_SLANT_NORMAL, cairo.FONT_WEIGHT_BOLD)
    ctx.set_font_size (size)
    for y in range(8):
        for x in range (16):
            c = str(chr (y*16+x))
            if (y*16+x)>31:
# With pgm, the -1,+1 shift is necessary (bug ?)
#                ctx.move_to (x*cw-min_x_bearing-1, y*ch-min_y_bearing+1)
                ctx.move_to (x*cw-min_x_bearing, (y+8)*ch-min_y_bearing)
                ctx.show_text (c)

    data = surface.get_data()
#    image = Image.fromstring ("L", (16*cw, 8*ch), data)
#    filename = '%s-%d.pgm' % (name, size)
#    print "Generating %s..." % filename, 
#    image.save (filename)
#    print 'done (character size is %dx%d)' % (cw, ch)

    file = open (filename, "w")
    file.write ("/* This file has been generated by makefont.py */\n\n");
    file.write ("#ifndef __FONT_%d__\n" % size)
    file.write ("#define __FONT_%d__\n\n" %size)
    file.write ("static const struct {\n")
    file.write ("    unsigned int width;\n")
    file.write ("    unsigned int height;\n")
    file.write ("    unsigned char data[%d*%d+1];\n" % (16*cw, 16*ch))
    file.write ("} font_%d = {\n" % size)
    file.write ("    %d, %d,\n" % (16*cw, 16*ch))
    file.write ("    \"")
    l = 0
    for i in range(16*cw*16*ch):
        c = data[i]
        t = "\\%o" % ord(c)
        file.write (t)
        l += len(t)
        if l > 64:
            file.write ("\"\n    \"")
            l = 0
    file.write ("\"\n};\n")
    file.write ("#endif\n")
    file.close()

makefont ('Mono', 12, 'font_12.h')
makefont ('Mono', 16, 'font_16.h')
makefont ('Mono', 24, 'font_24.h')
makefont ('Mono', 32, 'font_32.h')
